
//+------------------------------------------------------------------+
//|                                                                  |
//| disclaimer : centered triangular moving average                  |
//| recalculates last half cycle bars, and thus those                |
//| bars are subject of changing                                     |
//|                                                                  |
//+------------------------------------------------------------------+
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    TmaHalfPeriod   = 12;
extern int    TmaPrice        = PRICE_CLOSE;
extern int    MaPeriod        = 26;
extern int    MaMethod        = MODE_EMA;
extern int    MaPrice         = PRICE_CLOSE;
extern bool   AlertsOn        = false;
extern bool   AlertsOnCurrent = true;
extern bool   AlertsMessage   = true;
extern bool   AlertsSound     = false;
extern bool   AlertsEmail     = false;

//
//
//
//
//

double tma[];
double ma[];
double state[];
double hiu[];
double hid[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,hiu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hid); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,tma);
   SetIndexBuffer(3,ma);
   SetIndexBuffer(4,state);
   
      //
      //
      //
      //
      //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);    
     
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" Centered TMA - ma cross histo");  
return(0);
}  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(TmaHalfPeriod,Bars-counted_bars),Bars-1);
           if (returnBars) { hiu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     for(int i=limit; i>=0; i--)
     {
        hiu[i]   = EMPTY_VALUE;
        hid[i]   = EMPTY_VALUE;
        tma[i]   = icTma(TmaHalfPeriod,TmaPrice,i);
        ma[i]    = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i);
        state[i] = state[i+1]; 
           if (tma[i] > ma[i]) state[i] =  1;
           if (tma[i] < ma[i]) state[i] = -1;
           if (state[i] ==  1) hiu[i] = 1;
           if (state[i] == -1) hid[i] = 1;
     }       
     manageAlerts();
     return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         state[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",TmaHalfPeriod,TmaPrice,MaPeriod,MaMethod,MaPrice,AlertsOn,AlertsOnCurrent,AlertsMessage,AlertsSound,AlertsEmail,4,y);
         hiu[i]   = EMPTY_VALUE;
         hid[i]   = EMPTY_VALUE;
         if (state[i] ==  1) hiu[i] = 1;
         if (state[i] == -1) hid[i] = 1;  
   } 
return(0);         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

double icTma(int period, int price, int i)
{
   int j,k;
   double sum  = (period+1)*iMA(NULL,0,1,0,MODE_SMA,price,i);
   double sumw = (period+1);

      //
      //
      //
      //
      //
      
      for(j=1, k=period; j<period; j++,k--)
      {
         sum  += iMA(NULL,0,1,0,MODE_SMA,price,i+j)*k;
         sumw += k;
         if (j<=i)
         {
               sum  += iMA(NULL,0,1,0,MODE_SMA,price,i-j)*k;
               sumw += k;
         }
      }
   return(sum/sumw);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 

      //
      //
      //
      //
      //
      
      if (state[whichBar]!= state[whichBar+1])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (state[whichBar] ==  1) doAlert(time1,mess1," T3 crossed ma up");
            if (state[whichBar] == -1) doAlert(time1,mess1," T3 crossed ma down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(Symbol()+" T3 ma crosses",message);
          if (AlertsSound)   PlaySound("alert2.wav");
   }
}

